using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Threading;
using System.Diagnostics;
using System.Windows.Threading;


namespace AsyncApp
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>

    public partial class Window1 : System.Windows.Window
    {

        public Window1()
        {
            InitializeComponent();

            Debug.WriteLine("UI thread: " + Thread.CurrentThread.ManagedThreadId);

            fetchButton.Click += new RoutedEventHandler(fetchButton_Click);

            cancelButton.Click += new RoutedEventHandler(cancelButton_Click);
        }

        void cancelButton_Click(object sender, RoutedEventArgs e)
        {
            src.CancelGetData();
        }

        SlowThing src = new SlowThing();

        void fetchButton_Click(object sender, RoutedEventArgs e)
        {
            Debug.WriteLine("Click thread: " + Thread.CurrentThread.ManagedThreadId);

            cancelButton.IsEnabled = true;
            SynchronizationContext syncCtx = SynchronizationContext.Current;

            ThreadPool.QueueUserWorkItem(delegate
            {
                Debug.WriteLine("Threadpool thread: " + Thread.CurrentThread.ManagedThreadId);

                string data = src.Data;

                syncCtx.Post(delegate
                    {
                        cancelButton.IsEnabled = false;
                        Debug.WriteLine("Update thread: " + Thread.CurrentThread.ManagedThreadId);

                        result.Text = data;
                    }, null);
            });
        }

    }
}