﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Shapes;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;

namespace Commanding
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>

    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();

            this.CommandBindings.Add(
                new CommandBinding(
                    ApplicationCommands.Open,
                    OnOpen));

            CommandBinding closeBinding = new CommandBinding(
                                              ApplicationCommands.Close,
                                              OnClose);
            closeBinding.CanExecute += new CanExecuteRoutedEventHandler(closeBinding_CanExecute);
            this.CommandBindings.Add(closeBinding);
        }

        void closeBinding_CanExecute(object sender, CanExecuteRoutedEventArgs e)
        {
            e.CanExecute = isOpen;
        }

        bool isOpen = false;

        private void OnOpen(object sender, ExecutedRoutedEventArgs e)
        {
            MessageBox.Show("Open!");
            isOpen = true;
        }
        private void OnClose(object sender, ExecutedRoutedEventArgs e)
        {
            MessageBox.Show("Close!");
            isOpen = false;
        }
    }
}
