using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;

namespace DataBindingDemo
{
    public class Person : INotifyPropertyChanged
    {
        public Person()
        {
        }
        public Person(string name, double age)
        {
            this.Name = name;
            this.Age = age;
        }
        private string nameValue;

        public string Name
        {
            get { return nameValue; }
            set
            {
                if (value != nameValue)
                {
                    nameValue = value;
                    OnPropertyChanged("Name");
                }
            }
        }

        private double ageValue;

        public double Age
        {
            get { return ageValue; }
            set
            {
                if (value != ageValue)
                {
                    ageValue = value;
                    OnPropertyChanged("Age");
                }
            }
        }


        private void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }
}
