using System;
using System.Collections.Generic;
using System.Text;
using MtpsShowToc.Mtps;
using System.Threading;
using System.Xml;

namespace FakeMtpsService
{
    public class FakeGetContentService : MtpsShowToc.Mtps.ContentServicePortType
    {
        public GetContentResponse GetContent(GetContentRequest request)
        {
            Thread.Sleep(4000);

            getContentResponse response = new getContentResponse();
            response.primaryDocuments = new primary[1];
            primary tocDoc = new primary();
            response.primaryDocuments[0] = tocDoc;

            tocDoc.primaryFormat = "Mtps.Toc";
            XmlDocument toc = new XmlDocument();
            toc.LoadXml(fakeResponse);
            tocDoc.Any = toc.DocumentElement;

            return new GetContentResponse(response);
        }

        public GetNavigationPathsResponse GetNavigationPaths(GetNavigationPathsRequest request)
        {
            return null;
        }

        static string fakeResponse = @"<toc:Node toc:Title=""MSDN Library"" toc:SubTree=""AssetId:MSDN%7cuber%7c%24%5cuber.hxt%400%2c0"" toc:SubTreeVersion=""MSDN.10"" toc:SubTreeLocale=""en-us"" toc:Description="""" toc:Target=""AssetId:5DDC0A78-6B2C-43E3-9C56-55F45C0DFFA5"" toc:TargetLocale=""en-us"" toc:TargetVersion=""MSDN.10"" toc:IsPhantom=""false"" xmlns:toc=""urn:mtpg-com:mtps/2004/1/toc"" xmlns:mtps=""http://msdn2.microsoft.com/mtps"" xmlns:asp=""http://msdn2.microsoft.com/asp"" xmlns:mshelp=""http://msdn.microsoft.com/mshelp"">
            <toc:Node toc:Title=""Development Tools and Languages"" toc:SubTree=""AssetId:MSDN%7cdevtoolslang%7c%24%5cdevtoolslang.hxt%400%2c0"" toc:SubTreeVersion=""MSDN.10"" toc:SubTreeLocale=""en-us"" toc:Target=""AssetId:MSDN%7cdevtoolslang%7c%24%5cdevtoolslang.hxt%400%2c0"" toc:TargetLocale=""en-us"" toc:TargetVersion=""MSDN.10"" toc:IsPhantom=""false"" />
            <toc:Node toc:Title=""Mobile and Embedded Development"" toc:SubTree=""AssetId:MSDN%7cmobileembed%7c%24%5cmobileembed.hxt%400%2c0"" toc:SubTreeVersion=""MSDN.10"" toc:SubTreeLocale=""en-us"" toc:Target=""AssetId:MSDN%7cmobileembed%7c%24%5cmobileembed.hxt%400%2c0"" toc:TargetLocale=""en-us"" toc:TargetVersion=""MSDN.10"" toc:IsPhantom=""false"" />
            <toc:Node toc:Title="".NET Development"" toc:SubTree=""AssetId:MSDN%7cnetdev%7c%24%5cnetdev.hxt%400%2c0"" toc:SubTreeVersion=""MSDN.10"" toc:SubTreeLocale=""en-us"" toc:Target=""AssetId:MSDN%7cnetdev%7c%24%5cnetdev.hxt%400%2c0"" toc:TargetLocale=""en-us"" toc:TargetVersion=""MSDN.10"" toc:IsPhantom=""false"" />
            <toc:Node toc:Title=""Office Solutions Development"" toc:SubTree=""AssetId:MSDN%7cofficedev%7c%24%5cofficedev.hxt%400%2c0"" toc:SubTreeVersion=""MSDN.10"" toc:SubTreeLocale=""en-us"" toc:Target=""AssetId:MSDN%7cofficedev%7c%24%5cofficedev.hxt%400%2c0"" toc:TargetLocale=""en-us"" toc:TargetVersion=""MSDN.10"" toc:IsPhantom=""false"" />
            <toc:Node toc:Title=""Servers and Enterprise Development"" toc:SubTree=""AssetId:MSDN%7cserverentdev%7c%24%5cserverentdev.hxt%400%2c0"" toc:SubTreeVersion=""MSDN.10"" toc:SubTreeLocale=""en-us"" toc:Target=""AssetId:MSDN%7cserverentdev%7c%24%5cserverentdev.hxt%400%2c0"" toc:TargetLocale=""en-us"" toc:TargetVersion=""MSDN.10"" toc:IsPhantom=""false"" />
            <toc:Node toc:Title=""Web Development"" toc:SubTree=""AssetId:MSDN%7cwebdev%7c%24%5cwebdev.hxt%400%2c0"" toc:SubTreeVersion=""MSDN.10"" toc:SubTreeLocale=""en-us"" toc:Target=""AssetId:MSDN%7cwebdev%7c%24%5cwebdev.hxt%400%2c0"" toc:TargetLocale=""en-us"" toc:TargetVersion=""MSDN.10"" toc:IsPhantom=""false"" />
            <toc:Node toc:Title=""Win32 and COM Development"" toc:Target=""AssetId:MSDN%7cwin32com%7c%24%5cwin32com.hxt%400%2c0"" toc:TargetLocale=""en-us"" toc:TargetVersion=""MSDN.10"" toc:IsPhantom=""false"" />
            <toc:Node toc:Title=""MSDN Library Archive"" toc:SubTree=""AssetId:MSDN%7c%7c%7e%5chttp%3a%5cmsdn.microsoft.com%5carchive%5cdefault.asp"" toc:SubTreeVersion=""MSDN.10"" toc:SubTreeLocale=""en-us"" toc:Target=""AssetId:MSDN%7c%7c%7e%5chttp%3a%5cmsdn.microsoft.com%5carchive%5cdefault.asp"" toc:TargetLocale=""en-us"" toc:TargetVersion=""MSDN.10"" toc:IsPhantom=""false"" toc:ExternalUrl=""http://msdn.microsoft.com/archive/default.asp"" />
        </toc:Node>";


    }
}
