﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Media;
using System.Windows;
using System.Windows.Input;

namespace ProceduralRender
{
    public class CustomRender : FrameworkElement
    {
        Color currentBackground = Colors.Red;

        protected override void OnRender(DrawingContext drawingContext)
        {
            Rect r = new Rect(0, 0, ActualWidth, ActualHeight);
            drawingContext.DrawRectangle(new SolidColorBrush(currentBackground), null, r);

            Point ellipseCenter = new Point(ActualWidth / 2, ActualHeight / 2);
            drawingContext.DrawEllipse(Brushes.Yellow, new Pen(Brushes.Black, 2),
                ellipseCenter, ActualWidth / 2 - 4, ActualHeight / 2 - 4);

        }

        Random r = new Random();
        protected override void OnMouseDown(MouseButtonEventArgs e)
        {
            e.Handled = true;
            byte[] colourValues = new byte[3];
            r.NextBytes(colourValues);
            currentBackground = Color.FromRgb(colourValues[0], colourValues[1],
                colourValues[2]);

            InvalidateVisual();
        }
    }

}
