using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Printing;
using System.Windows.Xps;
using System.Windows.Markup;


namespace SimplePrinting
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>

    public partial class Window1 : System.Windows.Window
    {

        public Window1()
        {
            InitializeComponent();

            printButton.Click += new RoutedEventHandler(printButton_Click);
            printFlowDocButton.Click += new RoutedEventHandler(printFlowDocButton_Click);
            printApp.Click += new RoutedEventHandler(printApp_Click);
        }

        void printApp_Click(object sender, RoutedEventArgs e)
        {
            //DrawingGroup snapShot = VisualTreeHelper.GetDrawing(mainPanel);

            FixedDocument fdoc = new FixedDocument();
            FixedPage fpage = new FixedPage();
            PageContent pc = new PageContent();
            ((IAddChild) pc).AddChild(fpage);
            fdoc.Pages.Add(pc);

            Rectangle screenShot = new Rectangle();
            screenShot.Width = mainPanel.ActualWidth;
            screenShot.Height = mainPanel.ActualHeight;
            //screenShot.Fill = new DrawingBrush(snapShot);
            screenShot.Fill = Brushes.Green;

            fpage.Children.Add(screenShot);

            Window printPreview = new Window();
            DocumentViewer dv = new DocumentViewer();
            dv.Document = fdoc;
            printPreview.Content = dv;
            printPreview.ShowDialog();


            // 1: Get XpsDocumentWriter

            PrintDocumentImageableArea area = null;
            XpsDocumentWriter dw = PrintQueue.CreateXpsDocumentWriter(ref area);

        }

        void printFlowDocButton_Click(object sender, RoutedEventArgs e)
        {
            FlowDocument flowDoc = (FlowDocument) Application.LoadComponent(
                new Uri("FlowDocument1.xaml", UriKind.Relative));

            PrintDocumentImageableArea area = null;
            XpsDocumentWriter dw = PrintQueue.CreateXpsDocumentWriter(ref area);

            IDocumentPaginatorSource ps = flowDoc;
            dw.Write(ps.DocumentPaginator);
        }

        void printButton_Click(object sender, RoutedEventArgs e)
        {
            // 1: Get XpsDocumentWriter

            PrintDocumentImageableArea area = null;
            XpsDocumentWriter dw = PrintQueue.CreateXpsDocumentWriter(ref area);


            // 2: Generate content

            TextBlock tb = new TextBlock(); tb.Text = "Hello, world!";
            tb.Margin = new Thickness(area.OriginWidth, area.OriginHeight, 0, 0);


            // 3: Perform layout

            Size outputSize = new Size(area.MediaSizeWidth, area.MediaSizeHeight);
            tb.Measure(outputSize); tb.Arrange(new Rect(outputSize));
            tb.UpdateLayout();


            // 4: Write content to XpsDocumentWriter

            dw.Write(tb);
        }



    }
}